#!/bin/sh

TMP_SECTION=TmpAppliedFileRecord
APPLIED_RECORD_SECTION=AppliedFileRecord
BACKUP_APPLIED_RECORD_SECTION=BackupAppliedFileRecord
BACKUP_TAR=Backup.tgz

#This contains the files for smart rollback
SMART_BACKUP_TAR=SmartBackup.tgz

#
# handle special file: for example, tmsnmpd.conf can not be replaced directly
# Usage: F_special_file_handler backup/apply/rollback/stop_service/start_service backup_dir
#

F_special_file_handler(){
	#
	#supported action: backup/apply/rollback/stop_service/start_service
	#
	if [ "$1" == "" ];then
		echo "F_special_file_handler: param error: $0 backup/apply/rollback/stop_service/start_service backup_dir "
		return -1	
	else
		__action=$1
	fi
	if [ "$2" == "" ] ;then
		if [ "$1" == "backup" ] || [ "$1" == "rollback" ];then 
			echo "F_special_file_handler: param error: $0 backup/apply/rollback/stop_service/start_service backup_dir "
			return -1	
		fi
	else
		__backup_dir=$2
	fi
	
	
	__backup_special_dir="$__backup_dir/___iwsva_special"

	
	if [ $__action == "backup" ] || [ $__action == "apply" ];then
	    #do nothing here
	    :
		
		#if [ ! -f /usr/iwss/lib/snmp/libnetsnmpagent.so.15.1.2 ];then
		#       echo "We need to backup snmp lib files"
		#       __updated_snmp_lib="0"
		
		#fi       
	fi

	case $__action in
		"backup")
		#	if [ $__updated_snmp_lib = "0" ];then
		#	        cp -af /usr/iwss/lib/snmp/* $__backup_special_dir/snmp/
		#	        rm -fr /usr/iwss/lib/snmp/*
		#	fi
			;;
		"apply")
		#	if [ $__updated_tmsnmpd_conf == "0" ];then
		#
		#	fi
			       
			;;
		"rollback")
		#	if [ -f "$__backup_special_dir/`basename $file_tmsnmpd_conf`" ];then
		#		sed -i -e "s/# informsink /informsink /" $file_tmsnmpd_conf
		#		__updated_tm_snmpd_conf="0"
		#	fi
			;;
		"stop_service")
			;;
		"start_service")
			;;
		*)
			echo "F_special_file_handler: unsupported action: $__action"
			return -1
			;;
	esac
	return 0
}


F_stop_daemons() {
	#herb_todo: BCS each time we update hotfix, we should update iwssd, we should restart iwssd 
	#. Except for IWSS related service, you should still stop additional service here as necessary.
	#ex:
	#for s in svcmonitor MetricMgmtd logtodb canHttpd ftp proxy urld database maild agent; do
	#	/usr/iwss/S99IS$s stop
	#done
	#/etc/init.d/sshd stop
	/usr/iwss/rcIwss stop
	F_special_file_handler "stop_service"
	return 0	
}

F_start_daemons() {
	
	_restartSystem=`F_ini_get $PATCHINFOINI PatchInfo RestartSystem`
	if [ "$_restartSystem" = "1" ] ; then
		echo "Rebooting the system."
		reboot
		return 0
	elif [ "$_restartSystem" = "0" ] ; then
	  echo "Currently, no service need restart"
		#. Except for IWSS related service, you should still start additional service here as necessary.
		#ex:
	  #echo "Re-starting all daemons."
		#/usr/iwss/rcIwss restart
		#/etc/init.d/sshd start
	fi
	/usr/iwss/rcIwss start	
	F_special_file_handler "start_service"
}

# backup a list of files to a dir
# $1 install root dir 
# $2 backup dir
F_rollback(){

	echo "Rollback the files from backup dir $2 ..."
	_index=0
	_install_root=$1
	_backup_dir=$2

	if [ -f "$_backup_dir/$BACKUP_TAR" ] ; then
		echo "Rollback from $BACKUP_TAR"
		tar zxvf "$_backup_dir/$BACKUP_TAR" -C /
	else
		echo "No rollback because no $BACKUP_TAR." 
	fi
	
	if [ -f "$_backup_dir/$SMART_BACKUP_TAR" ] ; then
		echo "Rollback from $SMART_BACKUP_TAR"
		tar zxvf "$_backup_dir/$SMART_BACKUP_TAR" -C /
	else
		echo "No smart rollback because no $SMART_BACKUP_TAR." 
	fi

	#special files rollback
	/usr/iwss/S99ISsvcmonitor start
	/usr/iwss/S99ISftp start
	/usr/iwss/S99ISproxy start
	F_special_file_handler rollback $_backup_dir
	return 0
}

